package com.engine.salary.mapper.auth;

import com.engine.salary.entity.auth.dto.AuthRoleDataDTO;
import com.engine.salary.entity.auth.po.AuthRoleDataPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface AuthRoleDataMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<AuthRoleDataPO> listAll();
    
    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<AuthRoleDataPO> listSome(AuthRoleDataPO authRoleData);
    

	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	AuthRoleDataPO getById(Long id);
	
	/**
     * 新增，忽略null字段
     *
     * @param authRoleData 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(AuthRoleDataPO authRoleData);
    
    /**
     * 批量插入
     *
     * @param authRoleData
     */
    void batchInsert(@Param("collection") List<AuthRoleDataPO> authRoleData);
	
	/**
     * 修改，修改所有字段
     *
     * @param authRoleData 修改的记录
     * @return 返回影响行数
     */
	int update(AuthRoleDataPO authRoleData);
	
	/**
     * 修改，忽略null字段
     *
     * @param authRoleData 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(AuthRoleDataPO authRoleData);
	
	/**
     * 删除记录
     *
     * @param authRoleData 待删除的记录
     * @return 返回影响行数
     */
	int delete(AuthRoleDataPO authRoleData);
    
    /**
     * 批量删除记录
     * @param ids 主键id集合
     */
    void deleteByIds(@Param("ids") Collection<Long> ids);

	/**
	 * 根据角色id删除
	 * @param roleId roleId
	 */
	void deleteByRoleId(Long roleId);

    List<AuthRoleDataDTO> listRoleData(Long roleId);
}